(function () {
    "use strict";

    angular.module('core').controller('clienteVarejoController', controller);
    controller.$inject = ['$scope', '$timeout', 'contatoService', '$alert', 'lookupService', '$q'];

    function controller($scope, $timeout, contatoService, $alert, lookupService, $q) {
        $scope.initializeLayout('Clientes de Varejo');

        //[Inicializa objetos]
        $scope.state = {
            data: [],
            carregando: false,
            vazio: false,
            count: 0,
            filtro: {
                ativo: false,
                args: {
                    chaves: '',
                    ativo: null,
                    cpf: '',
                    chavesEmpresa: '',
                    indicaCliente: true,
                    indicaFornecedor: null,
                    indicaVendedor: null,
                    sortExpression: '',
                    skip: 0,
                    take: 20
                }
            },
        };

        $scope.auxiliar = {
            tipocliente: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllTipoCliente({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            empresa: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllEmpresa({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else {
                                    return response.Data;
                                }

                            })
                    );
                },
            },
            loja: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllLoja({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else {
                                    return response.Data;
                                }

                            })
                    );
                },
            },
            vendedor: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllVendedor({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else {
                                    return response.Data;
                                }

                            })
                    );
                },
            },
            endereco: {
                prepare: function (index) {
                    contatoService
                        .prepareEndereco($scope.state.item.Enderecos[index])
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                } else {
                                    $scope.state.item.Enderecos[index] = response.Data;
                                    $('[ng-model$="item.Linha2"]').focus();
                                }
                            },
                            function (_error) {
                                $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                            });
                },
                prepareNew: function () {
                    contatoService
                        .prepareNewEndereco($scope.state.item)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                } else {
                                    $scope.state.item = response.Data;
                                }
                            },
                            function (_error) {
                                $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                            });

                },
            },
        };


        $scope.popups = {
            add: {
                ativo: false,
                data: { Ativo: true, Cliente: { Ativo: true } },
                save: function (action) {

                    $scope.state.salvando = true;

                    if ($scope.popups.add.data.IndicaCliente == null)
                        $scope.popups.add.data.IndicaCliente = true;

                    contatoService
                        .save($scope.popups.add.data)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.state.salvando = false;
                                    $alert({ text: response.Message, title: $scope.Title });
                                } else {
                                    $scope.state.salvando = false;
                                    $scope.popups.add.ativo = false;
                                    $scope.popups.add.data = {};
                                    $scope.initialize();
                                }
                            },
                            function (_error) {
                                $scope.state.salvando = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                toggle: function () {
                    $scope.popups.add.ativo = !$scope.popups.add.ativo;

                }
            }
        };


        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.refresh();
        };

        $scope.getAll = function () {
            $scope.state.filtro.args.skip = 0;
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            contatoService
                .getAll($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            angular.copy(angular.fromJson(response.Data), $scope.state.data);
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = ($scope.state.data == 0);
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.count = function () {
            contatoService
                .count($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.count = response.Data;
                        }
                    },
                    function (_error) {
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.getMore = function () {
            $scope.state.filtro.args.skip += $scope.state.filtro.args.take;
            contatoService
                .getAll($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.data = $scope.state.data.concat(response.Data);
                        }
                    },
                    function (_error) {
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.refresh = function () {
            $scope.getAll();
            $scope.count();
        };

        $scope.clearFilter = function () {
            $scope.state.filtro.args.chaves = '';
            $scope.state.filtro.args.ativo = null;
            $scope.state.filtro.args.cpf = '';
            $scope.state.filtro.args.chavesEmpresa = '';
            $scope.state.filtro.args.indicaCliente = true;
            $scope.state.filtro.args.indicaFornecedor = null;
            $scope.state.filtro.args.indicaVendedor = null;

            $scope.refresh();
        };
        $scope.toggleFilter = function () {
            $scope.state.filtro.ativo = !$scope.state.filtro.ativo;
        };

        /*Inicializa funções*/
        $scope.initialize();

    }

})();